$(function() {

    // hide retry btn
    $('#retry').removeClass('hide').hide();

    if (!HAS_BOTTOM_SPACER) {
        $('.bottom_spacer').css({
            height: 0
        });
    }

    /**
     * retry button 
     */
    $('#retry').click(function(e) {
        e.preventDefault();
        $('#load').show();
        $(this).hide();
        Ti.App.fireEvent('detail:comment:' + WIN_ID + ':get_data');
        return false;
    });

    /**
     * open profile window when click on user name / avatar 
     */
    function openUserProfile(e) {
        e.preventDefault();
        var self = $(this);
        var userId = self.data('uid');
        if (userId) {
            Ti.App.fireEvent('detail:comment:' + WIN_ID + ':open_profile', {
                userId: userId
            });
        }
        return false;
    }

    /**
     * note: disable click to open own profile window if user is logged in
     * @param {Object} d
     * @return {String}
     */
    function createRow(d) {
        if (d.userId == USER_ID) { // hide link for logged in user
            d.user.hasLink = false;
        }
        return '<div>' + '<div class="single_comment">' + (d.user.hasLink ? '<a class="user_avatar" href="#" data-uid="' + d.userId + '">' : '<span class="user_avatar">') + '<img src="' + d.user.avatar + '" class="avt"/>' + (d.user.hasLink ? '</a>' : '</span>') + '<span class="user_comment break">' + '<h4>' + (d.user.hasLink ? '<a href="#" data-uid="' + d.userId + '" class="grey6">' + d.user.fullname + '</a>' : '<span class="grey6">' + d.user.fullname + '</span>') + '</h4>' + '<i class="grey5 f12">' + d.timeAgo + '</i><br/>' + '<p class="grey6">' + d.comment + '</p>' + '</span>' + '</div>' + '<div class="dash_line"></div>' + '</div>';
    }

    /**
     * render comments rows 
     * 
     * @param {Object} e
     *  - status {Boolean}
     *  - comments {Array<Object>}
     *    - userId {Number}
     *    - comment {String}
     *    - timestamp {Number}
     *    - timeago {String}
     *    - user {Object}
     *      - name {String}
     *      - fullname {String}
     *      - avatar {String}
     *      - hasLink {Boolean} - put link to go to profile window
     */
    function render(e) {

        Ti.API.info('[JMA] detail_comment:render, e.status:' + e.status + ', e.comments: ' + e.comments);

        if (e.status) {
            var html = '';
            for (var i = 0, len = e.comments.length; i < len; i++) {
                html += createRow(e.comments[i]);
            }
            var cmtWrap = $('#cmt_wrap');
            if (len == 0) {
                $('.page_wrap').addClass('no_comment');
                var blank = '<div class="comment_blank">' + '<h3>' + NO_COMMENT_YET + '</h3>' + '<span>' + BE_FIRST_COMMENT + '</span>' + '</div>';
                cmtWrap.html(blank);
            } else {
                cmtWrap.html(html);
                $('a[data-uid]').click(openUserProfile);
                $('.avt').bind('error', function() {
                    $(this).attr('src', './lib/ui/html/img/mdpi/grey_square.png');
                });
            }
        } else {
            $('#retry').show();
        }

        $('#load').hide();

    }
    Ti.App.addEventListener('detail:comment:' + WIN_ID + ':render', render);

    /**
     * append row for new comment
     * @param {Object} e
     *  - comment {String}
     *  - timeAgo {String}
     *  - user {Object}
     */
    function append(e) {
        Ti.API.info('[JMA] detail_comment.append(), e: ' + JSON.stringify(e));
        $('.comment_blank').remove();
        var html = createRow({
            userId: (e.user ? e.user.id : 0), // e.user should always an object - logged in user
            comment: e.comment,
            timeAgo: e.timeAgo,
            user: e.user
        });
        $('#cmt_wrap').append(html);
        Ti.API.info('[JMA] detail_comment.append(), html: ' + html);
        $('html, body').animate({
            scrollTop: $(document).height()
        }, 200); // scroll to bottom
    }
    Ti.App.addEventListener('detail:comment:' + WIN_ID + ':append', append);

    function unload() {
        Ti.API.info('[JMA] detail_comment.jsx unload');
        Ti.App.removeEventListener('detail:comment:' + WIN_ID + ':render', render);
        Ti.App.removeEventListener('detail:comment:' + WIN_ID + ':append', append);
    }
    Ti.App.addEventListener('detail:comment:' + WIN_ID + ':unload', unload);

    Ti.API.info('[JMA] detail_comment.jsx loaded');
    Ti.App.fireEvent('detail:comment:' + WIN_ID + ':ready');
});