$(function() {

    // hide retry btn
    $('#retry').removeClass('hide').hide();

    if (!HAS_BOTTOM_SPACER) {
        $('.bottom_spacer').css({
            height: 0
        });
    }

    /**
     * retry button 
     */
    $('#retry').click(function(e) {
        e.preventDefault();
        $('#load').show();
        $(this).hide();
        Ti.App.fireEvent('detail:info:' + WIN_ID + ':get_data');
        return false;
    });

    function showPreview() {
        var idx = parseInt($(this).data('idx'));
        if (!isNaN(idx)) {
            Ti.App.fireEvent('detail:info:' + WIN_ID + ':show_preview', {
                idx: idx
            });
        }
    }

    /**
     * @param {Object} e
     *  - status {Boolean}
     *  - maxHeight {Number}
     *  - previews {Array<String>}
     *  - description {String}
     *  - isIos {Boolean}
     */
    function render(e) {

        Ti.API.info('[JMA] detail_info:render, e.status:' + e.status + ', e.maxHeight: ' + e.maxHeight + ', e.previews: ' + e.previews + ', e.description: ' + e.description);

        if (e.status) {

            // construct preview & paging bullet html
            var preview = '<ul class="slides">';
            for (var i = 0, prevs = e.previews.length; i < prevs; i++) {
                preview += '<li>'; // style="min-height:' + e.maxHeight + 'px">';
                preview += '<img src="' + e.previews[i] + '" data-idx="' + i + '"/>';
                preview += '</li>';
            }
            preview += '</ul>';
            $('#preview').html(preview);

            // ios: slider img with swipe, android: no swipe
            $('.slides li').css({
                'min-height': e.maxHeight + 'px'
            });
            $('.slides img')
                .css({
                    maxHeight: e.maxHeight + 'px'
                })
                .bind('error', function() {
                    $(this)
                        .css({
                            height: (e.maxHeight / 2) + 'px'
                        })
                        .attr('src', './lib/html/img/mdpi/grey_portrait.png');
                });
            //	.click(showPreview); // temporary disable
            $('.flexslider').flexslider({
                animation: 'slide',
                animationLoop: false,
                slideshow: false,
                touch: e.isIos,
                controlNav: false
            });

            // set description		
            $('#description').html($('<p>' + e.description + '</p>'));

        } else {
            $('#retry').show();
        }
        $('#load').hide();
    }
    Ti.App.addEventListener('detail:info:' + WIN_ID + ':render', render);

    function unload() {
        Ti.API.info('[JMA] detail_info.jsx unload');
        Ti.App.removeEventListener('detail:info:' + WIN_ID + ':render', render);
    }
    Ti.App.addEventListener('detail:info:' + WIN_ID + ':unload', unload);

    Ti.API.info('[JMA] detail_info.jsx loaded');
    Ti.App.fireEvent('detail:info:' + WIN_ID + ':ready');

});