$(function() {

    // hide retry btn
    $('#retry').removeClass('hide').hide();

    if (!HAS_BOTTOM_SPACER) {
        $('.bottom_spacer').css({
            height: 0
        });
    }

    /**
     * retry button 
     */
    $('#retry').click(function(e) {
        e.preventDefault();
        $('#load').show();
        $(this).hide();
        Ti.App.fireEvent('detail:jazzes:' + WIN_ID + ':get_data');
        return false;
    });

    /**
     * open link in browser
     */
    function openLink(e) {
        e.preventDefault();
        Ti.App.fireEvent('detail:jazzes:' + WIN_ID + ':open_link', {
            url: $(this).data('url')
        });
        return false;
    }

    /** 
     * @param {Object} e
     *  - status {Boolean}
     *  - jazzes {Array<Object>}
     *    - title {String}
     *    - link {String}
     *    - timestamp {Number}
     *    - timedelta {String}
     */
    function render(e) {

        Ti.API.info('[JMA] detail_jazzes:render, e.status:' + e.status + ', e.jazzes: ' + e.jazzes);

        if (e.status) {
            var html = '';
            for (var i = 0, len = e.jazzes.length; i < len; i++) {
                var f = e.jazzes[i];
                html += '<div class="mb20 jazz_card" data-url="' + f.link + '">';
                html += '<p class="grey6 mb5"><a>' + f.name + '</a></p>';
                html += '<p class="f12 grey6"><i class="grey5"> ' + f.timedelta + '</i></p>';
                html += '</div>';
            }

            $('#jazzes').html(html);
            $('.jazz_card[data-url]').click(openLink);

        } else {
            $('#retry').show();
        }
        $('#load').hide();
    }
    Ti.App.addEventListener('detail:jazzes:' + WIN_ID + ':render', render);

    function unload() {
        Ti.API.info('[JMA] detail_jazzes.jsx unload');
        Ti.App.removeEventListener('detail:jazzes:' + WIN_ID + ':render', render);
    }
    Ti.App.addEventListener('detail:jazzes:' + WIN_ID + ':unload', unload);

    Ti.API.info('[JMA] detail_jazzes.jsx loaded');
    Ti.App.fireEvent('detail:jazzes:' + WIN_ID + ':ready');

});